var jsBridge = {};
(function (jsBridge) {
    /**
    * 判断环境
    */
    var userAgent = navigator.userAgent;
    jsBridge.os = {
        isIphone: userAgent.indexOf('iPhone') > -1 ? true : false,
        isIpad: userAgent.indexOf('iPad') > -1 ? true : false,
        isIOS: !!userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/) ? true : false,
        isAndroid: (userAgent.indexOf('Android') > -1 || userAgent.indexOf('Linux') > -1) ? true : false,
        isQQ:userAgent.toLowerCase().match(/QQ/i) == "qq"?true:false,
        isWeChat:userAgent.toLowerCase().match(/MicroMessenger/i) == "micromessenger"?true:false,
    }
    jsBridge.isMobile = function(){
    if((navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i)))
      return true;
    else
      return false;
    }

    /**
     * 自定义社交分享
     * @param options
     * {
     *  plat:'wx,wxopen,qq,qqopen',  微信、微信朋友圈、QQ、QQ空间
     *  head:'',
     *  url:'',
     *  title:'',
     *  logo:'',
     *  content:''
     * }
     */
    jsBridge.share = function(options,callback){
        var json = JSON.stringify(options);
        dsBridge.call("share",json, function (response) {
          if (typeof callback == "function") {
            callback(response)
          }
        })
    }

    /**
     * 是否游客模式
     * 如果返回1不是游客模式，0游客模式
     * @param options
     * {
     *
     * }
     */
    jsBridge.checkAuthority = function(options,callback){
        dsBridge.call("checkAuthority",options,function (response) {
          if (typeof callback == "function") {
            callback(response)
          }
        })
    }

    /**
     * 获取token
     * 返回
     *  avatar  用户头像
     *  id
     *  name
     *  token
     * @param options
     */
    jsBridge.getUserInfo = function(options,callback){
        dsBridge.call("getUserInfo",options,function (response) {
          if (typeof callback == "function") {
            callback(response)
          }
        })
    }

    /**
     * 存储app缓存
     * 返回
     *
     * @param options
     */
    jsBridge.saveWebViewValue = function(options,callback){
        dsBridge.call("saveWebViewValue",options,function (response) {
          if (typeof callback == "function") {
            callback(response)
          }
        })
    }

    /**
     * 获取app缓存
     * 返回
     *
     * @param options
     */
    jsBridge.getWebViewValue = function(options,callback){
        dsBridge.call("getWebViewValue",options,function (response) {
          if (typeof callback == "function") {
            callback(response)
          }
        })
    }
    /**
     * 点返回跳到指定页面
     * 返回
     *type
     *raceid
     *title
     * @param options
     */
    jsBridge.navGoPage = function(options,callback){
      var json = JSON.stringify(options)
        dsBridge.call("navGoPage",json,function (response) {
          if (typeof callback == "function") {
            callback(response)
          }
        })
    }


    /**
     * 直播跳转
     * @param {Object} options：跳转直播参数:
     * {
     * 	url：播放地址
     * 	id: 播放id
     *  type: 1为播放器，2为H5，3为都可以
     *  platform_type: 直播平台名称
     * }
     * @param {Function} callback：回调函数
     */
    jsBridge.toLive = function(options, callback) {
    	var json = JSON.stringify({LinkData:options});
    	dsBridge.call("toLive",json,function (response) {
    		if (typeof callback == "function") {
        		callback(response)
        	}
    	});
    }


    /**
	 * 跳转到天梯
	 * @param {String} options：有三个参数，''：空字符串，跳转到天梯首页，CJ_Detail：跳转到吃鸡详情，WZ_Detail：跳转到王者详情，都是字符串，如：jsBridge.toLadder('CJ_Detail',function(response){})
	 * @param {Function} callback：回调函数
	 */
	jsBridge.toLadder = function(options, callback) {
		dsBridge.call("toLadder", options, function (response) {
			if (typeof callback == "function") {
	        	callback(response)
	        }
		});
	}

	/**
	 * 获取设备号
	 * @param {String} options：只需传一个 '' 空字符串即可
	 * @param {Function} callback：回调函数
	 */
	jsBridge.getDeviceInfo = function(options, callback) {
		dsBridge.call("getDeviceInfo", options, function (response) {
			if (typeof callback == "function") {
	        	callback(response)
	        }
		});
	}

	/**
	 * 用途：赛事详情页（newRace.blade.php/myRace.blade.php/raceMap.blade.php，369行/1149行/215行）分享功能桥接
	 * @param{Object} options：分享参数，title: 分享标题，content: 分享内容，logo: 赛事logo，url：分享链接
	 * @param{Function} callback：回调函数
	 */
	jsBridge.appShare = function(options, callback) {
		var json = JSON.stringify(options);
		dsBridge.call("appShare",json, function (response) {
			if (typeof callback == "function") {
	        	callback(response)
	        }
		});
	}

	/**
	 * 用途：赛事详情页（newRace.blade.php，460行）跳转决金杯新闻栏目
	 * @param {Object} options：跳转参数，newsName: 新闻名称（如"决金杯"），newsId：新闻栏目id
	 * @param {Function} callback：回调函数
	 */
	jsBridge.toNewsInfo = function(options, callback) {
		var json = JSON.stringify(options);
		dsBridge.call("toRaceNewsInfo",json, function (response) {
			if (typeof callback == "function") {
	        	callback(response)
	        }
		});
	}

	/**
	 * 用途：当用户报名成功后，先与APP源生确认是否是第一次打开app，是则弹出新手引导（myRace.blade.php，2253行）
	 * @param {String} options：调用参数为空，传''
	 * @param {Function} callback：回调函数
	 */
	jsBridge.firstEnterMyRace = function(options, callback) {
		dsBridge.call("checkFirstEnterRacePage", options, function (response) {
			if (typeof callback == "function") {
	        	callback(response)
	        }
		});
	}


  /**
	 * 用途：JS调用QQ授权成功后发送code给原生
	 * @param {String} options：授权code
	 */
	jsBridge.qqAuthCode = function(options) {
		dsBridge.call("qqAuthCode",options, function () {});
	}

  /**
	 * 用途：IOS点击返回上一页按钮时直接返回到首页,需在页面刚加载完成时执行
	 */
	jsBridge.navGoBack = function() {
    var state = {title: "title",url: "#"};
    window.history.pushState(state, "title", "#");
    window.addEventListener("popstate", function(){
      dsBridge.call("navGoBack","");
    }, false);
	}
  /**
	 * 用途：APP内跳转至原生页面，分常规跳转及Banner跳转两类
	 * @param {Object} options：
      type:{label:'无',value:'0'},{label:'赛事',value:'1'},{label:'天梯',value:'2'},{label:'娱乐',value:'3'},{label:'V币商城',value:'4'},{label:'成长',value:'5'},{label:'竞猜',value:'6'},{label:'外部链接',value:'7'},{label:'新闻',value:'8'},{label:'幸运转盘',value:'9'},{label:'幸运夺宝',value:'12'},{label:'消消乐',value:'13'},{label:'限时红包',value:'14'},{label:'邀请好友',value:'15'},{label:'礼包兑换码',value:'16'},{label:'天梯房页面',value:'17'},{label:'天梯限时活动',value:'18'},{label:'超值拼团',value:'19'},{label:'社区跳转',value:'20'}
      Banner类型跳转：
        type: 跳转值（与后台配置相同），typeId：下属ID（如存在即跳完其对应下级页面，如商品ID，新闻ID。）,name: Banner型跳转下为空；
        ex:{type:4,typeId:15,name:''}
      常规类型跳转：
        type: 0（常规型跳转传0），typeId：下属ID（如存在即跳完其对应下级页面，如房间号。）,name: 跳转的名称
        ex:{type:0,typeId:'',name:'guess'}
        {type:0,typeId:'',name:'activity'}跳转限时活动
	 */
	jsBridge.openAppView = function(options,callback) {
    var json = JSON.stringify(options);
		dsBridge.call("openAppView",json, function (response) {
      if (typeof callback == "function") {
      	callback(response)
      }
    });
	}
  /**
	 * 获取设备信息
	 * @param {String} options：只需传一个 '' 空字符串即可
	 * @param {Function} callback：回调函数:
   * {models:手机型号,brand:iOS or android,network:网络状态,device:设备号}
	 */
	jsBridge.getDevice = function(options, callback) {
		dsBridge.call("getDevice", options, function (response) {
			if (typeof callback == "function") {
      	callback(response)
      }
		});
	}
  /**
   * App内使用系统组件播放视频
   * @param {Object} options：url:视频地址
   * @param {Function} callback：回调函数
   */
  jsBridge.openVideo = function(options, callback) {
    var json = JSON.stringify(options);
    dsBridge.call("openVideo", json, function (response) {
      if (typeof callback == "function") {
        callback(response)
      }
    });
  }
  /**
	 * 用途：APP内点击图片查看大图（支持多张）
   * @param {Object} options：
     url:图片url，current：图片排序，默认0
   *
	 */
  jsBridge.imagesEnlarge = function(options,callback) {
    var json = JSON.stringify(options);
    dsBridge.call("imagesEnlarge",json, function (response) {
      if (typeof callback == "function") {
        callback(response)
      }
    });
  }

	/**
	 * 通用跳转外链方法
	 * @param {Object} options：{url: ...}
	 * @param {Object} callback
	 */
	jsBridge.goOuterLink = function(options,callback) {
		  var json = JSON.stringify(options);
    	dsBridge.call("goOuterLink",json, function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}

  /**
	 * 获取服务端时间
	 */
	jsBridge.getServerTime = function(callback) {
    	dsBridge.call("getServerTime",'', function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}

	/**
	 * 当子页面返回当前页面后，刷新当前页面
	 * @param {Function} callback
	 */
	jsBridge.reloadPage = function(callback) {
    	dsBridge.call("reloadPage","1", function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}
	
	/**
	 * 拉起QQ聊天
	 * 因为QQ号是源生配的，只需请求这个桥接，让他们拉起就好
	 * @param {Function} callback
	 */
	jsBridge.chartForQQ = function(callback) {
    	dsBridge.call("chartForQQ",'', function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}
	
	/**
	 * 跳转至成长
	 * @param {Function} callback
	 */
	jsBridge.goGrouUp = function(callback) {
		dsBridge.call("goGrouUp",'', function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}
	
	/**
	 * 跳转至等级
	 * @param {Function} callback
	 */
	jsBridge.goLevelExp = function(callback) {
		dsBridge.call("goLevelExp",'', function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}
	
	/******************** 助力拼团桥接 ********************/

  	/**
	 * 获取助力拼团商品信息
	 * @param {String} options：只需传一个 '' 空字符串即可
	 * @param {Function} callback：回调函数:
	 */
	jsBridge.getMallList = function(options, callback) {
		dsBridge.call("getMallList", options, function (response) {
			if (typeof callback == "function") {
      	callback(response)
      }
		});
	}

	/**
	 * 跳转至充值外链
	 * @param {Object} options：只需传一个'' 空字符串即可
	 * @param {Object} callback：回调函数
	 */
	jsBridge.goRecharge = function(callback) {
    	dsBridge.call("goRecharge",'', function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}

  /**
	 * 获取拼团广播栏
   * @param {String} options：字符串 index:首页广播  joinGroup:参与拼团
	 * @param {Object} callback：回调函数
	 */
	jsBridge.getAdvertising = function(options,callback) {
    	dsBridge.call("getAdvertising",options, function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}

  /**
	 * 根据商品id获取拼团商品数据
   * @param {Object} options：商品id ex:{id:1}
	 * @param {Object} callback：回调函数
	 */
	jsBridge.getGoodsData = function(options,callback) {
      var json = JSON.stringify(options);
    	dsBridge.call("getGoodsData",json, function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}

	/**
	 * 支付
	 * @param {Object} options：支付参数，为商品id，收货地址，开团方式：0为开团，1为拼团，拼团id:若为自己开团传0，否则传id,msg：买家留言
	 * 例：{productId: 10, addressInfo: {name: 'BBB', phone: '1232121', address: "福建省厦门市中航"}, joinType: '0/1', joinTeamId: '10', msg: ''}
	 * @param {Function} callback：回调函数
	 */
	jsBridge.doPay = function(options, callback) {
		var json = JSON.stringify(options);
    	dsBridge.call("doPay",json, function (response) {
      		if (typeof callback == "function") {
        		callback(response)
      		}
    	});
	}

  /**
   * 获取我的拼团订单
   */
  jsBridge.getOrders = function(options,callback) {
    var json = JSON.stringify(options);
    dsBridge.call("getOrders",json, function (response) {
        if (typeof callback == "function") {
          callback(response)
        }
    });
  }

  /**
   * 根据url地址原生解析获取html结构
   * @param {Object} options: url地址 ex:{url:'http://p3imc956r.....'}
   */
  jsBridge.creatDom = function(options,callback) {
    var json = JSON.stringify(options);
    dsBridge.call("creatDom",json, function (response) {
      if (typeof callback == "function") {
        callback(response)
      }
    });
  }

  /**
   * 根据group_id获取拼团信息
   * @param {Object} options：商品id，开团id ex:{good_id: 1,group_id:1}
   */
  jsBridge.getGroupInfo = function(options,callback) {
    var json = JSON.stringify(options);
    dsBridge.call("getGroupInfo",json, function (response) {
      if (typeof callback == "function") {
        callback(response)
      }
    });
  }

  /**
   * 通知源生关闭当前页面
   * @param {Function} callback：回调函数
   */
  jsBridge.closePage = function(callback) {
    dsBridge.call("closePage",'', function (response) {
      if (typeof callback == "function") {
        callback(response)
      }
    });
  }

  /**
   * 获取我的拼团订单详情
   * @param {Object} options：商品id，开团id ex:{good_id: 1,group_id:1}
   */
  jsBridge.getOrdersDetail = function(options,callback) {
    var json = JSON.stringify(options);
    dsBridge.call("getOrdersDetail",'', function (response) {
      if (typeof callback == "function") {
        callback(response)
      }
    });
  }

  /**
   * 删除订单
   * @param {Object} options：商品id，开团id ex:{group_id:1}
   */
  jsBridge.removeOrders = function(options,callback) {
    var json = JSON.stringify(options);
    dsBridge.call("removeOrders",json, function (response) {
      if (typeof callback == "function") {
        callback(response)
      }
    });
  }
  /**
   * 分享成功统计
   * @param options
   * 拼团id ex:{group_id:group_id}
   */
  jsBridge.shareEventLog = function(options){
    var json = JSON.stringify(options);
    dsBridge.call("shareEventLog",json, function () {})
  }
  
	/******************** 社区桥接 ********************/
	
	/**
	 * 跳转至社区个人中心
	 * @param {Object} options：参数
	 * @param {Function} callback：回调函数
	 */
	jsBridge.goPersonalCenter = function(options, callback) {
		var json = JSON.stringify(options);
	    dsBridge.call("goPersonalCenter",json, function (response) {
	    	if (typeof callback == "function") {
	    		callback(response)
	    	}
	    });
	}
	
	/**
	 * 举报帖子
	 * @param {Object} options
	 * @param {Function} callback
	 */
	jsBridge.doReport = function(options, callback) {
		var json = JSON.stringify(options);
	    dsBridge.call("doReport",json, function (response) {
	    	if (typeof callback == "function") {
	    		callback(response)
	    	}
	    });
	}
	
	/**
	 * 回复评论
	 * @param {Object} options
	 * @param {Function} callback
	 */
	jsBridge.doComment = function(options, callback) {
		var json = JSON.stringify(options);
	    dsBridge.call("doComment",json, function (response) {
	    	if (typeof callback == "function") {
	    		callback(response)
	    	}
	    });
	}
	
	/**
	 * 编辑帖子
	 * @param {Object} options
	 * @param {Function} callback
	 */
	jsBridge.goEditPost = function(options, callback) {
		var json = JSON.stringify(options);
	    dsBridge.call("goEditPost",json, function (response) {
	    	if (typeof callback == "function") {
	    		callback(response)
	    	}
	    });
	}
})(jsBridge)

function loadBridge(type,link){
    var sendData = {
        type:type,
        name:'',
        typeId:link,
    }
    jsBridge.openAppView(sendData,function(){})
}
